<?php

function rever_option_styles(){
    //Body
    $body_default = array(
        'font-size'   => '16px',
        'font-family' => 'Droid Sans',
        'font-weight' => '400',
        'font-backup' => 'Arial, Helvetica, sans-serif',
    );
    $body_bg = rever_option('body_bg', array('background-color' => '#f5f5f5'));
    $body_typography = rever_option('body_font', $body_default);
    $body_typography['font-backup'] = !empty($body_typography['font-backup']) ? $body_typography['font-backup'] : 'Arial, Helvetica, sans-serif';

    //Heading
    $heading_default = array('font-family' => 'Poppins', 'font-weight' => '700');
    $heading_typography = rever_option('heading_font', $heading_default);    
    
    //Meta
    $meta_default = array('font-family' => 'Droid Sans', 'font-weight' => '400', 'font-size' => '12px', 'text-transform' => 'none');
    $meta_typography = rever_option('meta_font', $meta_default);    
    
    //Menu
    $menu_default = array('font-family' => 'Poppins', 'font-weight' => '700', 'font-size' => '10px', 'text-transform' => 'uppercase');
    $menu_typography = rever_option('menu_font', $menu_default);    
    $submenu_default = array('font-family' => 'Poppins', 'font-weight' => '700', 'font-size' => '10px', 'text-transform' => 'uppercase');
    $submenu_typography = rever_option('submenu_font', $submenu_default);    
    
    
    $primary_color = rever_option('primary_color', '#1de118');
    $body_color = rever_option('body_color', '#444');
    $heading_color = rever_option('heading_color', '#151515');
    $link_color = rever_option('link_color', array('regular' => '#808080', 'hover' => '#999'));
    $meta_color = rever_option('post_metacolor', '#999');
    $header_bg = rever_option('header_bgcolor', '#151515');
    $header_color = rever_option('menu_color', '#ccc');
    $menu_hover = rever_option('menu_hover', '#fff');
    $submenu_bg = rever_option('submenu_bg', '#151515');
    $submenu_color = rever_option('submenu_color', '#ccc');
    $submenu_hover = rever_option('submenu_hover_color', '#fff');
    $submenu_hoverbg = rever_option('submenu_hover_bg', '#222222');
    $post_bg_color = rever_option('post_bg_color', '#fff');
    $post_link = rever_option('post_link', array('regular' => '#151515', 'hover' => '#999'));
    $border_color = rever_option('border_color', '#e6e6e6');
    $input_bg = rever_option('input_bg', '#f5f5f5');
    $footer_color = rever_option('footer_text_color', '#999');
    $footer_link = rever_option('footer_link_color', array('regular' => '#999', 'hover' => '#151515'));
    
    $header_height = rever_option('header_height', '70');
    $slider_height = rever_option('slider_height', '560');
    $slider_height2 = rever_option('slider_height2', '630');
    
    $h1_font_size = rever_option('h1_font', '36px');
    $h2_font_size = rever_option('h2_font', '30px');
    $h3_font_size = rever_option('h3_font', '24px');
    $h4_font_size = rever_option('h4_font', '20px');
    $h5_font_size = rever_option('h5_font', '16px');
    $h6_font_size = rever_option('h6_font', '14px');
    
    $output = '';
    $output .= 'body{';
        $output .= !empty($body_color) ? ('color: '.esc_attr($body_color).';') : '';
        $output .= !empty($body_typography['font-family']) ? ('font-family: "'.esc_attr($body_typography['font-family']).'", '.esc_attr($body_typography['font-backup']).';') : '';
        $output .= !empty($body_typography['font-size']) ? ('font-size: '.esc_attr($body_typography['font-size']).';') : '';
        $output .= !empty($body_typography['font-weight']) ? ('font-weight: '.esc_attr($body_typography['font-weight']).';') : '';
    $output .= '}';
    $output .= 'body.page-template-page-rowbuilder{';
        $output .= !empty($body_bg['background-color']) ? ('background-color:'.esc_attr($body_bg['background-color']).';') : '';
    $output .= '}';
    $output .= 'h1, h2, h3, h4, h5, h6, blockquote:before, .tw-pagination, aside.widget ul, body .btn,'
            . 'input[type="submit"], input[type="button"], button,'
            . ' .tw-button, .tw-footer, .error-desc, article.single .comment-count, .entry-share > a{';
        $output .= !empty($heading_typography['font-family']) ? ('font-family: "'.esc_attr($heading_typography['font-family']).'";') : '';
    $output .= '}';
    $output .= 'h1, h2, h3, h4, h5, h6, .tw-pagination, aside.widget ul, body .btn, .tw-button, article.single .comment-count, .entry-share > a{';
        $output .= !empty($heading_typography['font-weight']) ? ('font-weight: '.esc_attr($heading_typography['font-weight']).';') : '';
    $output .= '}';

    $output .= '.sf-menu > li > a, .tw-mobile-menu nav ul li a, .tw-header-socials .social-title{';
        $output .= !empty($menu_typography['font-family']) ? ('font-family: "'.esc_attr($menu_typography['font-family']).'";') : '';
        $output .= !empty($menu_typography['font-size']) ? ('font-size: '.esc_attr($menu_typography['font-size']).';') : '';
        $output .= !empty($menu_typography['font-weight']) ? ('font-weight: '.esc_attr($menu_typography['font-weight']).';') : '';
        $output .= !empty($menu_typography['text-transform']) ? ('text-transform: '.esc_attr($menu_typography['text-transform']).';') : '';
    $output .= '}';
        
        $output .= '.sf-menu ul{';
            $output .= !empty($submenu_typography['font-family']) ? ('font-family: "'.esc_attr($submenu_typography['font-family']).'";') : '';
            $output .= !empty($submenu_typography['font-size']) ? ('font-size: '.esc_attr($submenu_typography['font-size']).';') : '';
            $output .= !empty($submenu_typography['font-weight']) ? ('font-weight: '.esc_attr($submenu_typography['font-weight']).';') : '';
            $output .= !empty($submenu_typography['text-transform']) ? ('text-transform: '.esc_attr($submenu_typography['text-transform']).';') : '';
        $output .= '}';
        
        $output .= '.tw-meta{';
            $output .= !empty($meta_typography['font-family']) ? ('font-family: "'.esc_attr($meta_typography['font-family']).'";') : '';
            $output .= !empty($meta_typography['font-size']) ? ('font-size: '.esc_attr($meta_typography['font-size']).';') : '';
            $output .= !empty($meta_typography['font-weight']) ? ('font-weight: '.esc_attr($meta_typography['font-weight']).';') : '';
            $output .= !empty($meta_typography['text-transform']) ? ('text-transform: '.esc_attr($meta_typography['text-transform']).';') : '';
        $output .= '}';
        
        
        $output .= '::selection{
            background-color: '. esc_attr($primary_color).';
        }';
        $output .= '::moz-selection{
            background-color: '. esc_attr($primary_color).';
        }';
        
        $output .= '.tw-contact i, h3.widget-title:after,
        .sf-mobile-menu .menu-item-has-children>.before,
        .sf-menu .menu-item-has-children:after,
        blockquote:before, .instagram-pics .like-count,
        .tw-blog article.sticky .entry-post:before{
            color: '. esc_attr($primary_color) .';
        }';
        
        $output .= '#scroll-bar,
        .widget .post-count,
        .tw-social-icon > a:before, .tw-button:before,
        .owl-theme .owl-controls .owl-dot.active span,
        .owl-theme .owl-controls.clickable .owl-dot:hover span,
        .owl-carousel-meta .owl-prev:hover,
        .owl-carousel-meta .owl-next:hover,
        .tw-mobile-menu .owl-carousel .owl-dot.active span,
        .tw-mobile-menu .owl-carousel .owl-dot:hover span{
            background-color: '. esc_attr($primary_color).';
        }';
        
        $output .= '.entry-cats a, h3.widget-title >span,
        .tw-blog article.sticky .entry-post{
            border-color: '. esc_attr($primary_color).';
        }';
        
        $output .= 'a{';
            $output .= !empty($link_color['regular']) ? ('color: '.esc_attr($link_color['regular']).';') : '';
        $output .= '}';
        $output .= 'a:hover{';
            $output .= !empty($link_color['hover']) ? ('color: '.esc_attr($link_color['hover']).';') : '';
        $output .= '}';
        
        $output .= 'h1, h2, h3, h4, h5, h6, aside.widget ul li a{
            color: '. esc_attr($heading_color).';
        }';
        $output .= '.tw-meta, .entry-cats, .tw-pagination a, .feature-area .feature-title > p{
            color: '. esc_attr($meta_color).';
        }';
        
        $output .= 'h1{';
            $output .= !empty($h1_font_size['font-size']) ? ('font-size: '.esc_attr($h1_font_size['font-size']).';') : '';
        $output .= '}';
        $output .= 'h2{';
            $output .= !empty($h2_font_size['font-size']) ? ('font-size: '.esc_attr($h2_font_size['font-size']).';') : '';
        $output .= '}';
        $output .= 'h3{';
            $output .= !empty($h3_font_size['font-size']) ? ('font-size: '.esc_attr($h3_font_size['font-size']).';') : '';
        $output .= '}';
        $output .= 'h4{';
            $output .= !empty($h4_font_size['font-size']) ? ('font-size: '.esc_attr($h4_font_size['font-size']).';') : '';
        $output .= '}';
        $output .= 'h5{';
            $output .= !empty($h5_font_size['font-size']) ? ('font-size: '.esc_attr($h5_font_size['font-size']).';') : '';
        $output .= '}';
        $output .= 'h6{';
            $output .= !empty($h6_font_size['font-size']) ? ('font-size: '.esc_attr($h6_font_size['font-size']).';') : '';
        $output .= '}';
        
        $output .= !empty($header_bg) ? ('.header-small .tw-menu-container, .tw-menu-container, .header-area.layout-2 .tw-logo, .header-clone{background-color:'.esc_attr($header_bg).';}') : '';
        $output .= !empty($header_color) ? ('.tw-header-meta i, .tw-menu .sf-menu, .tw-mobile-menu nav ul li a{color:'.esc_attr($header_color).';} .nav-icon span{background-color:'.esc_attr($header_color).'}') : '';
        $menu_hover_selectors = 'h1.site-name, .tw-header-meta i:hover, .sf-menu > li:hover > a';
        $output .= !empty($menu_hover) ? ($menu_hover_selectors.'{color:'.esc_attr($menu_hover).';} .nav-icon:hover span{background-color:'.esc_attr($menu_hover).'}') : '';
        $output .= !empty($submenu_bg) ? ('.sf-menu ul{background-color:'.esc_attr($submenu_bg).';}') : '';
        $output .= !empty($submenu_color) ? ('.sf-menu ul, .sf-menu .sub-menu .menu-item-has-children:after{color:'.esc_attr($submenu_color).';}') : '';
        $output .= !empty($submenu_hover) ? ("\n". '.tw-menu .page_item > ul.children li:hover > a, .tw-menu .sub-menu li:hover > a, .sf-menu .sub-menu .menu-item-has-children:hover:after, .tw-header-socials .tw-social-icon i{color:'.esc_attr($submenu_hover).';}') : '';
        $output .= !empty($submenu_hoverbg) ? ("\n". '.tw-menu .page_item > ul.children li:hover > a, .tw-menu .sub-menu li:hover > a, .tw-header-socials .tw-social-icon a:before{background-color:'.esc_attr($submenu_hoverbg).';}') : '';
        $output .= !empty($footer_color) ? ('.tw-footer, .tw-footer .footer-menu a{color:'.esc_attr($footer_color).';}') : '';
        $output .= !empty($footer_link['regular']) ? ('.tw-footer a{color:'.esc_attr($footer_link['regular']).';}') : '';
        $output .= !empty($footer_link['hover']) ? ('.tw-footer a:hover{color:'.esc_attr($footer_link['hover']).';}') : '';
        
        if(!empty($header_height)){
            $output .= '.sf-menu > li > a, .tw-header-socials .social-title{line-height: '.intval($header_height).'px;}';
            $output .= '.tw-menu-container, .header-clone, .tw-mobile-menu .tw-logo{height:'.intval($header_height).'px;}';
        }
        
        if(!empty($slider_height)){
            $output .= '.tw-slider .slider-item{height: '.intval($slider_height).'px;}';
            $output .= '.tw-slider.slider4 .col-md-4 .slider-item{height: '.((intval($slider_height) / 2) - 15).'px;}';
            $output .= '@media (max-width: 1199px){ .tw-slider .slider-item{height: '.(940*intval($slider_height) / 1170).'px;}';
            $output .= '.tw-slider.tw-slider.slider4 .col-md-4 .slider-item{height: '.(((940*intval($slider_height) / 1170) / 2) - 10).'px;}}';
        }
        if(!empty($slider_height2)){
            $output .= '.tw-slider.slider1 .slider-item{height: '.intval($slider_height2).'px;}';
            $output .= '.single-media-container.with-img{min-height: '.intval($slider_height2).'px;}';
        }
        
        if(!empty($border_color)){
            $rgba_border = rever_hex2rgb($border_color);
            $output .= 'table, td, th, .content-row, .comment-text, .widget ul li, .tw-footer{border-color:'.esc_attr($border_color).';}';
            $output .= '.header-area.layout-2 .tw-logo{border-color: rgba('.esc_attr($rgba_border).',0.5);}';
            $output .= 'input, input[type="tel"], input[type="date"], input[type="text"], input[type="password"], input[type="email"], textarea, select{border-color: rgba('.esc_attr($rgba_border).',0.6);}';
        }
        if(!empty($input_bg)){
            $output .= 'input, input[type="tel"], input[type="date"], input[type="text"], input[type="password"], input[type="email"], textarea, select,';
            $output .= '.tagcloud > a, .entry-tags a, body.single-post .tw-author-box, .nextprev-postlink-container, .search-opened .tw-header-meta form.searchform input{background-color:'.esc_attr($input_bg).';}';
        }
        if(!empty($post_bg_color)){
            $output .= '.tw-blog article, .tw-blog.grid-blog article .entry-post-container';
            $output .= '.single-content, .sidebar-area .widget-item, .tw-pagination{background-color:'.esc_attr($post_bg_color).';}';
        }
        $output .= !empty($post_link['regular']) ? ('.page-content > p a, .entry-content > p:not(.tw-button) a{color:'.esc_attr($post_link['regular']).';}') : '';
        $output .= !empty($post_link['hover']) ? ('.page-content > p a:hover, .entry-content > p:not(.tw-button) a:hover{color:'.esc_attr($post_link['hover']).';}') : '';
        
        $output .= rever_option('custom_css');
        
        return $output;
}