<?php
function rever_option($index, $default = ''){
    global $rever_redux;
    if ( isset( $rever_redux[ $index ]) ) {
        return $rever_redux[$index];
    } else {
        return $default;
    }
}
function rever_metabox($index, $default = ''){
    global $post;
    $metabox = !empty($post->ID) ? get_post_meta( $post->ID, REVER_META, true ) : '';
    if ( isset( $metabox[ $index ]) ) {
        return $metabox[$index];
    } else {
        return $default;
    }
}
function rever_metaboxes(){
    global $post;
    if ($post) {
        return get_post_meta( $post->ID, REVER_META, true );
    }
    return false;
}
function rever_favicon() {
    if(!function_exists('wp_site_icon') || !has_site_icon()){
        $fav = rever_option('favicon');
        if (!empty($fav['url'])) {
            $favicon = $fav['url'];
        } else {
            $favicon = REVER_DIR . 'assets/img/favicon.png';
        }
        echo '<link rel="shortcut icon" href="' . esc_url($favicon) . '" />' . "\n";
    }
}

// Print menu
//=======================================================
function rever_menu() {
    wp_nav_menu(array(
        'container' => false,
        'menu_id' => '',
        'menu_class' => 'sf-menu',
        'fallback_cb' => 'rever_nomenu',
        'theme_location' => 'main'
    ));
}
function rever_footer_menu() {
    wp_nav_menu(array(
        'container' => 'div',
        'container_class' => 'footer-menu',
        'menu_id' => '',
        'menu_class' => '',
        'fallback_cb' => '',
        'theme_location' => 'footer',
        'depth' => '1'
    ));
}

function rever_nomenu() {
    echo "<ul class='sf-menu'>";
        $howmany = 5;
        $pages=wp_list_pages(array('title_li'=>'','echo'=>0));
        preg_match_all('/(<li.*?>)(.*?)<\/li>/i', $pages, $matches);
        if(!empty($matches[0])){echo implode("\n", array_slice($matches[0],0,5));}
    echo "</ul>";
}
function rever_mobilemenu($loc = 'main') {
    wp_nav_menu(array(
        'container' => false,
        'menu_id' => '',
        'menu_class' => 'sf-mobile-menu clearfix',
        'fallback_cb' => 'rever_nomobile',
        'theme_location' => $loc)
    );
}

function rever_nomobile() {
    echo "<ul class='clearfix'>";
    wp_list_pages(array('title_li' => ''));
    echo "</ul>";
}


// Print logo
//=======================================================
function rever_logo($mobile = false) {
    $logo = rever_option("logo");
    $output = '<div class="tw-logo">';
        if ( !empty($logo['url']) ) {
            $output .= '<a class="logo" href="' . esc_url(home_url('/')) . '">';
                $output .= '<img class="logo-img" src="' . esc_url($logo['url']) . '" alt="' . esc_attr(get_bloginfo('name')) . '"/>';
            $output .= '</a>';
        } else {
            $output .= '<h1 class="site-name"><a class="logo" href="' . esc_url(home_url('/')) . '">';
                $output .= get_bloginfo('name');
            $output .= '</a></h1>';
        }
        if($mobile){
            $output .= '<div class="nav-icon-container"><div class="nav-icon tw-mdl-close active"><span></span><span></span><span></span></div></div>';
        }
    $output .= '</div>';
    return $output;
}
// ThemeWaves Pagination
//=======================================================
function rever_pagination($blog_query, $type = 'simple') { 
    global $paged;
    $pages = intval($blog_query->max_num_pages);
    $paged = ($paged) ? intval($paged) : 1;
    if (empty($pages)) {
        $pages = 1;
    }
    if($type == 'simple' && 1 != $pages){
        echo '<div class="tw-pagination tw-nextprev-link">';
            echo '<div class="newer">';
                previous_posts_link('<span><i class="ion-chevron-left"></i>'.rever_option('text_newer', esc_html__( 'Newer Posts', 'rever')).'</span>', $blog_query->max_num_pages);
            echo '</div><div class="older">';
                next_posts_link('<span>'.rever_option('text_older', esc_html__( 'Older Posts', 'rever')).'<i class="ion-chevron-right"></i></span>', $blog_query->max_num_pages);
            echo '</div>';
        echo '</div>';
    }elseif($type == 'number' && 1 != $pages){
        $big = 9999; // need an unlikely integer
        echo "<div class='tw-pagination'>";
        $pagination = paginate_links(
            array(
                'base' => str_replace($big, '%#%', esc_url(get_pagenum_link($big))),
                'end_size' => 3,
                'mid_size' => 6,
                'format' => '?paged=%#%',
                'current' => max(1, get_query_var('page')),
                'total' => $blog_query->max_num_pages,
                'type' => 'list',
                'prev_text' => rever_option('text_prev', esc_html__( 'Prev', 'rever')),
                'next_text' => rever_option('text_next', esc_html__( 'Next', 'rever')),
            )
        );
        echo balanceTags($pagination);
        echo "</div>";
    }elseif($type == 'infinite' && 1 != $pages){
        wp_enqueue_script('owl-carousel');
        wp_enqueue_script('waypoints');
        echo '<div class="tw-pagination tw-infinite-scroll" data-has-next="' . ($paged === $pages ? 'false' : 'true') . '">';
        echo '<div class="loading"><div class="infinte-loader"></div></div>';
        echo '<div class="older"><a class="next" href="' . esc_url(get_pagenum_link($paged + 1)) . '"><span>'.rever_option('text_loadmore', esc_html__( 'More Stories', 'rever')).'</span></a></div>';
        echo '</div>';
    }
}

function rever_get_image_by_id($id,$url=false,$size='full'){
    $lrg_img=wp_get_attachment_image_src($id,$size);
    $output='';
    if(isset($lrg_img[0])){
        if($url){
            $output.=$lrg_img[0];
        }else{
            $output.='<img src="'.esc_url($lrg_img[0]).'" />';
        }
    }
    return $output;
}

if (!function_exists('rever_image')) {
    function rever_image($size = 'full', $returnURL = false) {
        global $post;
        $attachment = get_post(get_post_thumbnail_id($post->ID));
        if(!empty($attachment)){
            if ($returnURL) {
                $lrg_img = wp_get_attachment_image_src($attachment->ID, $size);
                $url = $lrg_img[0];
                $alt0 = get_post_meta($attachment->ID, '_wp_attachment_image_alt', true);
                $alt = empty($alt0)?$attachment->post_title:$alt0;
                $caption = get_post( get_post_thumbnail_id() )->post_excerpt;
                $img['url'] = $url;
                $img['alt'] = $alt;
                $img['caption'] = $caption;
                return $img;
            } else {
                return get_the_post_thumbnail($post->ID,$size);
            }
        }
    }
}

if (!function_exists('rever_single_title')) {
    function rever_single_title(){
        echo '<h1 class="entry-title">'.get_the_title().'</h1>';
        if(rever_option('single_meta', true)){
            echo '<div class="tw-meta">';
                $tw_author_email = get_the_author_meta('email');
                echo '<span class="entry-author">'.get_avatar($tw_author_email, $size = '40').esc_html__('by', 'rever').'&nbsp;';
                    the_author_posts_link();  
                echo '</span><span class="entry-date"><a href="'.esc_url(get_permalink()).'">'.get_the_time(get_option('date_format')).'</a></span>';
                if(rever_option('single_cats', true)){
                    echo '<span class="entry-cats"><span>&nbsp;'.esc_html__('in', 'rever').'&nbsp;</span>'.rever_cats().'</span>';
                }
                echo rever_comment_count('tw-button');
            echo '</div>';
        }
    }
}

if (!function_exists('rever_author')) {
    function rever_author(){ 
        $description = get_the_author_meta('description');
        if ($description != ''){ ?>
        <div class="tw-author-box">
            <div class="author-box">
                <?php
                $tw_author_email = get_the_author_meta('email');
                echo get_avatar($tw_author_email, $size = '100');
                ?>
                <h3><?php
                    if (is_author()){
                        the_author();
                    }else{
                        the_author_posts_link();
                    } ?>
                </h3>
                <?php
                    echo esc_html($description);
                $socials = get_the_author_meta('user_social');
                if(!empty($socials)){
                    echo '<div class="author-entry-share">';
                    $social_links=explode("\n",$socials);
                    foreach($social_links as $social_link){
                        $icon = rever_social_icon(esc_url($social_link));
                        echo '<a href="'.esc_url($social_link).'"><i class="'.esc_attr($icon['class']).'"></i></a>';
                    }
                    echo '</div>';
                } ?>
            </div>
        </div><?php
        }
    }
}

if (!function_exists('rever_comment_form')) {
    function rever_comment_form($fields) {
        global $id, $post_id;
        if (null === $post_id)
            $post_id = $id;
        else
            $id = $post_id;

        $commenter = wp_get_current_commenter();
        $req = get_option('require_name_email');
        $aria_req = ( $req ? " aria-required='true'" : '' );

        $fields = array(
            'author' => '<p class="comment-form-author">' .
            '<input id="author" name="author" placeholder="' . esc_html__('Name *', 'rever') . '" type="text" value="' . esc_attr($commenter['comment_author']) . '" size="30"' . $aria_req . ' />' . '</p>',
            'email' => '<p class="comment-form-email">' .
            '<input id="email" name="email" placeholder="' . esc_html__('Email *', 'rever') . '" type="text" value="' . esc_attr($commenter['comment_author_email']) . '" size="30"' . $aria_req . ' />' . '</p>',
            'url' => '<p class="comment-form-url">' .
            '<input id="url" name="url" placeholder="' . esc_html__('Website', 'rever') . '" type="text" value="' . esc_attr($commenter['comment_author_url']) . '" size="30" />' . '</p><div class="clearfix"></div>',
        );
        return $fields;
    }
    add_filter('comment_form_default_fields', 'rever_comment_form');
}

if (!function_exists('rever_comment')) {
    function rever_comment($comment, $args, $depth){
        $GLOBALS['comment'] = $comment;
        switch ( $comment->comment_type ) :
            case 'pingback' :
            case 'trackback' :
		// Display trackbacks differently than normal comments.
        ?>
        <div class="comment post pingback" id="comment-<?php comment_ID(); ?>">
            <div class="comment-text">
                <?php _e( 'Pingback:', 'rever' ); ?> <?php comment_author_link(); ?> <?php edit_comment_link( __( '(Edit)', 'rever' ), '<span class="edit-link">', '</span>' ); ?>
            </div>
                <?php
                break;
            default :
            // Proceed with normal comments.
            global $post;
        ?>
        <div <?php comment_class();?> id="comment-<?php comment_ID(); ?>">
            <div class="comment-author">
                <?php echo get_avatar($comment, $size = '65'); ?>
            </div>
            <div class="comment-text">
                <h3 class="author"><?php echo get_comment_author_link(); ?></h3>
                <span class="tw-meta"><?php echo get_comment_date('F j, Y'); ?></span>
                <?php comment_text() ?>
                <h6 class="reply"><?php comment_reply_link(array_merge($args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?></h6>
            </div>
            <?php
		break;
	    endswitch; // end comment_type check
    }
}

if (!function_exists('rever_comment_count')) {
    function rever_comment_count($class = '') {
        if (comments_open()) {
            $comment_count = get_comments_number('0', '1', '%');
            if ($comment_count == 0) {
                $comment_trans = esc_html__('no comment', 'rever');
            } elseif ($comment_count == 1) {
                $comment_trans = esc_html__('1 comment', 'rever');
            } else {
                $comment_trans = $comment_count . ' ' . esc_html__('comments', 'rever');
            }
            if($class){
                $class .= ' ';
            }
            return "<span class='".esc_attr($class)."comment-count'><a href='" . esc_url(get_comments_link()) . "' title='" . esc_attr($comment_trans) . "'>" . esc_html($comment_trans) . "</a></span>";
        }
    }
}
function rever_cats($sep = ', '){
    $cats = '';
    foreach((get_the_category()) as $category) {
        $options = get_option("taxonomy_".$category->cat_ID);
        if (!isset($options['featured']) || !$options['featured']){
            $cats .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . sprintf( __( 'View all posts in %s', 'rever' ), $category->name ) . '" ' . '>'  . $category->name.'</a><span>'.$sep.'</span>';
        }
    }
    if(!$cats && is_search()){
        $cats = '<a href="' . get_permalink() . '">' . esc_html__('Page', 'rever') . '</a>';
    }
    return $cats;
}
if (!function_exists('rever_categories_postcount')){
	function rever_categories_postcount($variable) {
		$pos = strpos($variable, '<option');
		if (!$pos) {
			$variable = str_replace('(', '<span class="post-count">', $variable);
			$variable = str_replace(')', '</span>', $variable);
		}
		return $variable;
	}
}
add_filter('wp_list_categories', 'rever_categories_postcount');
add_filter('get_archives_link', 'rever_categories_postcount');

if (!function_exists('rever_post_share')) {
    function rever_post_share() {
        $output = '<div class="tw_post_sharebox clearfix">';
            $output .= '<span class="share-text">'.esc_html__('Share this Post', 'rever').'</span>';
            $post_title = get_the_title();
            $output .= '<div class="sharebox-icons">';
                $output .= '<div class="google"><a href="' . esc_url(get_permalink()) . '" title="Share this"><i class="ion-social-googleplus"></i></a></div>';
                $output .= '<div class="twitter-share"><a href="' . esc_url(get_permalink()) . '" title="Tweet" data-title="' . esc_attr($post_title) . '"><i class="ion-social-twitter"></i></a></div>';
                $output .= '<div class="facebook-share"><a href="' . esc_url(get_permalink()) . '" title="Share this"><i class="ion-social-facebook"></i></a></div>';
            $output .= '</div>';
        $output .= '</div>';
        echo balanceTags($output);
    }
}

if(!function_exists('rever_origshare_count')){
    function rever_origshare_count($socials = array('facebook', 'twitter', 'pinterest')){
        $count = 0;
        foreach($socials as $social){
            if($social == 'facebook'){
                $url = get_permalink();
                $contents=false;
                try {
                    $contents = wp_remote_get('http://graph.facebook.com/?id='.$url);
                } catch(Exception $e) {
                    $s_count = 0;
                }
                if(is_array($contents)&&isset($contents['body'])) {
                        $json = json_decode($contents['body']);
                        $s_count = isset($json->share->share_count) ? $json->share->share_count : 0;
                } else {
                        $s_count = 0;
                }
            } elseif($social == 'pinterest') {
                $contents=false;
                $url = get_permalink();
                try {
                    $contents = wp_remote_get('http://widgets.pinterest.com/v1/urls/count.json?source=6&url='.$url);
                } catch(Exception $e) {
                    $s_count = 0;
                }
                if(is_array($contents)&&isset($contents['body'])) {
                        $contents['body']=str_replace(array('receiveCount(',')'),'',$contents['body']);
                        $json = json_decode($contents['body']);
                        $s_count = isset($json->count) ? $json->count : 0;
                } else {
                        $s_count = 0;
                }
            } elseif($social == 'twitter'){
                global $post;
                $s_count = get_post_meta($post->ID, 'post_twitter', true);
            }
            $count += intval($s_count, 10);
        }
        return $count;
    }
}

if (!function_exists('rever_share_count')){

    function rever_share_count($socials = array('facebook', 'twitter', 'pinterest')){
        global $post;       
        $count = 0;
        foreach($socials as $social){
            $s_count = get_post_meta($post->ID, 'post_' . $social, true);
            $count += intval($s_count, 10);
        }
        return intval($count, 10);
    }

}
if (isset($_REQUEST['social_pid']) && isset($_REQUEST['social_name'])){
    $pid = intval($_REQUEST['social_pid']);
    update_post_meta($pid, 'post_' . $_REQUEST['social_name'], get_post_meta($pid, 'post_' . $_REQUEST['social_name'], true) + 1);
    die;
}

function rever_social_link($link){  
    if(!empty($link)){
        $social = rever_social_icon(esc_url($link));
        return '<a title="'.esc_attr($social['name']).'" href="'.esc_url($link).'" class="'.esc_attr($social['name']).'"><i class="'.esc_attr($social['class']).'"></i></a>';
    }
}
function rever_social_icon($url){
    if(strpos($url,'twitter.com')) { $social['name']='twitter';$social['class']='ion-social-twitter';return $social; }
    if(strpos($url,'linkedin.com')){ $social['name']='linkedin';$social['class']='ion-social-linkedin';return $social;}
    if(strpos($url,'facebook.com')){ $social['name']='facebook';$social['class']='ion-social-facebook';return $social;}
    if(strpos($url,'delicious.com')) { $social['name']='delicious';$social['class']='fa fa-delicious';return $social;}
    if(strpos($url,'codepen.io')){ $social['name']='codepen';$social['class']='ion-social-codepen';return $social;}
    if(strpos($url,'github.com')){ $social['name']='github';$social['class']='ion-social-github';return $social;}
    if(strpos($url,'wordpress.org')||strpos($url,'wordpress.com')){$social['name']='wordpress';$social['class']='ion-social-wordpress';return $social;}
    if(strpos($url,'youtube.com')){$social['name']='youtube';$social['class']='ion-social-youtube';return $social;}
    if(strpos($url,'behance.net')){$social['name']='behance';$social['class']='fa fa-behance';return $social;}
    if(strpos($url,'pinterest.com')){$social['name']='pinterest';$social['class']='ion-social-pinterest';return $social;}
    if(strpos($url,'foursquare.com')){$social['name']='foursquare';$social['class']='ion-social-foursquare';return $social;}
    if(strpos($url,'soundcloud.com')){$social['name']='soundcloud';$social['class']='fa fa-soundcloud';return $social;}
    if(strpos($url,'dribbble.com')){$social['name']='dribbble';$social['class']='ion-social-dribbble';return $social;}
    if(strpos($url,'instagram.com')){$social['name']='instagram';$social['class']='ion-social-instagram';return $social;}
    if(strpos($url,'plus.google')||strpos($url,'google.com')){$social['name']='google';$social['class']='ion-social-googleplus';return $social;}
    if(strpos($url,'reddit.com')){$social['name']='reddit';$social['class']='fa fa-reddit';return $social;}
    if(strpos($url,'vimeo.com')){$social['name']='vimeo';$social['class']='fa fa-vimeo';return $social;}
    if(strpos($url,'vine.co')) { $social['name']='vine';$social['class']='fa fa-vine';return $social;}
    if(strpos($url,'twitch.tv')){$social['name']='twitch';$social['class']='ion-social-twitch';return $social;}
    if(strpos($url,'tumblr.com')){$social['name']='tumblr';$social['class']='ion-social-tumblr';return $social;}
    if(strpos($url,'apple.com')){ $social['name']='apple';$social['class']='ion-social-apple';return $social;}
    if(strpos($url,'trello.com')){$social['name']='trello';$social['class']='fa fa-trello';return $social;}
    if(strpos($url,'microsoft.com')){ $social['name']='microsoft'; $social['class']='ion-social-windows';return $social;}
    if(strpos($url,'spotify.com')){$social['name']='spotify';$social['class']='fa fa-spotify';return $social;}
    if(strpos($url,'snapchat.com')) { $social['name']='snapchat';$social['class']='ion-social-snapchat';return $social;}
    
    $social['name']='newsfeed';
    $social['class']='ion-social-rss';
    return $social;
}
function rever_social_name_from_url($social_link,$option){
    return trim(str_replace(array_merge(array('https:','http:','www.','/'),$option), '',$social_link));
}

function rever_related_posts($posts_per_page) {
    global $post;
    
    if (!empty($posts_per_page) && $categories = get_the_category($post->ID)) {
        $category_ids = array();

	foreach($categories as $individual_category) $category_ids[] = $individual_category->term_id;
	
	$args = array(
		'category__in'     => $category_ids,
		'post__not_in'     => array($post->ID),
		'posts_per_page'   => $posts_per_page, // Number of related posts that will be shown.
		'ignore_sticky_posts' => 1
	);
        $atts['img_size'] = 'rever_grid_thumb';
        $my_query = new wp_query( $args );
	if( $my_query->have_posts() ) { ?>
            <div class="related-posts">
                <h4><?php esc_html_e('Related posts', 'rever'); ?></h4>
                <div class="row">
		<?php while( $my_query->have_posts() ) {
			$my_query->the_post();?>
                        <div class="col-md-6">
                            <div class="related-item">
                                <?php 
                                    $format = get_post_format();
                                    echo rever_entry_media($format, $atts);
                                    
                                    echo '<h2 class="entry-title"><a href="'.esc_url(get_permalink()).'">'.get_the_title().'</a></h2>'; 
                                    if(rever_option('single_meta', true)){
                                        echo '<div class="tw-meta"><span class="entry-author">'.esc_html__('by', 'rever').'&nbsp;';
                                            the_author_posts_link();  
                                            echo '</span><span class="entry-date"><a href="'.esc_url(get_permalink()).'">'.get_the_time(get_option('date_format')).'</a></span>';
                                            echo rever_comment_count();
                                        echo '</div>';
                                    }
                                    
                                ?>
                            </div>
                        </div>
		<?php
		}
		echo '</div>';
            echo '</div>';
	}
        wp_reset_postdata();
    }
}

function rever_seen_add(){
    global $post;
    $seen = get_post_meta($post->ID,'post_seen',true);
    $seen = intval($seen)+1;
    update_post_meta($post->ID,'post_seen',$seen);
}
function rever_seen_count(){
    global $post;
    $seen = get_post_meta($post->ID,'post_seen',true);
    return (empty($seen)?0:$seen);    
}

// Hex To RGB
function rever_hex2rgb($hex) {
    $hex = str_replace("#", "", $hex);

    if (strlen($hex) == 3) {
        $r = hexdec(substr($hex, 0, 1) . substr($hex, 0, 1));
        $g = hexdec(substr($hex, 1, 1) . substr($hex, 1, 1));
        $b = hexdec(substr($hex, 2, 1) . substr($hex, 2, 1));
    } else {
        $r = hexdec(substr($hex, 0, 2));
        $g = hexdec(substr($hex, 2, 2));
        $b = hexdec(substr($hex, 4, 2));
    }
    $rgb = array($r, $g, $b);
    return implode(",", $rgb); // returns the rgb values separated by commas
}

add_filter( 'wp_get_attachment_image_attributes', 'rever_image_attr',10,3);
function rever_image_attr($attr,$attachment,$size){
    global $_wp_additional_image_sizes;
    if (!empty($attachment->post_mime_type) && $attachment->post_mime_type === 'image/gif' && isset($attachment->guid)){
        $width=$height=0;
        if(is_array($size)){
            list($width,$height)=$size;
        }elseif(is_string($size)&&isset($_wp_additional_image_sizes[$size])){
            $width=$_wp_additional_image_sizes[$size]['width'];
            $height=$_wp_additional_image_sizes[$size]['height'];
        }else{
            $width =get_option($size.'_size_w');
            $height=get_option($size.'_size_h');
        }
        $attr['data-animated_src'] = $attachment->guid;
        $attr['data-width']  = $width;
        $attr['data-height'] = $height;
        $attr['onload'] = 'loadGifImage(this)';
        $attr['class'].=' ever-gif';        
        if($attr['src']===$attachment->guid){
            $img=wp_get_attachment_image_src($attachment->ID,'thumb');
            if(isset($img[0])){
                $attr['src']=$img[0];
            }
        }
    }
    return $attr;
}