<?php

/**
 * Initialize the custom Meta Boxes. 
 */
add_action('admin_init', 'rever_page_options');

function rever_page_options() {
    
    $categories = get_categories("hide_empty=0&parent=0");
    $cats = array("0" => esc_html__("All Category", 'rever'));
    if (!empty($categories)) {
        foreach ($categories as $category) {
            $cats[$category->slug] = $category->name;
        }
    }
    
    $blog_layouts = array(
        'simple' => array('text'=>esc_html__('Simple', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/01.png')),
        'grid' => array('text'=>esc_html__('Grid', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/02.png')),
        'list' => array('text'=>esc_html__('List', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/03.png')),
        'list2' => array('text'=>esc_html__('List right thumb', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/04.png')),
        'square' => array('text'=>esc_html__('Featured', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/05.png')),
        'llist' => array('text'=>esc_html__('Large List', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/06.png')),
        'llist2' => array('text'=>esc_html__('Large List right thumb', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/07.png')),
        'square3' => array('text'=>esc_html__('Featured Large', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/08.png')),
        'grid4' => array('text'=>esc_html__('Grid Large', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/09.png')),
        'square2' => array('text'=>esc_html__('Featured 2 columns', 'rever'),'src'=>esc_url(REVER_DIR . 'assets/img/10.png')),
    );

    $page_options = array(
        Array(
            'name' => esc_html__('Select slider layout?', 'rever'),
            'id' => 'slider',
            'std' => '',
            'type' => 'layout',
            'options'=>array(
                '' => array(
                    'title' => esc_html__('Slider None', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_empty.png'
                ),
                'slider1' => array(
                    'title' => esc_html__('Slider 1', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_1.png'
                ),
                'slider2' => array(
                    'title' => esc_html__('Slider 2', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_2.png'
                ),
                'slider3' => array(
                    'title' => esc_html__('Slider 3', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_3.png'
                ),
                'slider4' => array(
                    'title' => esc_html__('Slider 4', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_4.png'
                ),
                'custom' => array(
                    'title' => esc_html__('Custom shortcode', 'rever'),
                    'img' => REVER_DIR . 'assets/img/custom_option.png'
                )
            ),
        ),
        Array(
            'name' => esc_html__('Select category?', 'rever'),
            'id' => 'slider_cat',
            'std' => '',
            'type' => 'select',
            'options'=> $cats,
            'dependency' => array(
                'element' => 'slider',
                'value' => array('slider1', 'slider2', 'slider3', 'slider4', 'slider5'),
            ),
        ),
        Array(
            'name' => esc_html__('Slider Post Count?', 'rever'),
            'id' => 'slider_post_count',
            'std' => '',
            'placeholder' => esc_html__('Insert only Digits here', 'rever'),
            'type' => 'text',
            'dependency' => array(
                'element' => 'slider',
                'value' => array('slider1', 'slider2', 'slider3', 'slider4', 'slider5'),
            ),
        ),
        Array(
            'name' => esc_html__('Custom shortcode?', 'rever'),
            'id' => 'slider_shortcode',
            'std' => '',
            'placeholder' => esc_html__('Example: [revslider id="3"]', 'rever'),
            'type' => 'text',
            'dependency' => array(
                'element' => 'slider',
                'value' => array('custom'),
            ),
        ),
        Array(
            'name' => esc_html__('Blog Layout', 'rever'),
            'id' => 'blog_layout',
            'std' => '',
            'desc' => esc_html__('Choose Row and Add Row and assign Row Layout, You can also Delete! Note: If you selected All Categories then only 1 Row will enough and delete the other styles.', 'rever'),
            'type' => 'blog',
            'options'=>array(
                'layout' => $blog_layouts,
                'cats' => $cats,
                'posts_per_page' => '',
                'excerpt' => '',
                'sidebar' => array('false' => 'False', 'true' => 'True'),
                'pagination' => array('none' => 'None', 'simple' => 'Simple', 'number' => 'Numbered', 'infinite' => 'Infinite'),
            )
        ),
    );
    
    
    add_meta_box('page_meta_settings', esc_html__('Page settings', 'rever'), 'rever_postmetabox', 'page', 'normal', 'core', $page_options);

}
