<?php

/**
 * Initialize the custom Meta Boxes. 
 */
add_action('admin_init', 'rever_post_options');

function rever_post_options() {

    $post_options = array(     
        Array(
            'name' => esc_html__('Choose Post Single Layout', 'rever'),
            'id' => 'single_layout',
            'std' => '',
            'desc' => esc_html__('Default will follow the Theme Option setting.', 'rever'),
            'type' => 'layout',
            'options' => array(
                '' => array(
                    'title' => esc_html__('Default', 'rever'),
                    'img' => REVER_DIR . 'assets/img/default_option.png'
                ),
                'right-sidebar' => array(
                    'title' => esc_html__('Right Sidebar', 'rever'),
                    'img' => REVER_DIR . 'assets/img/single_rightsidebar.png'
                ),
                'narrow-content' => array(
                    'title' => esc_html__('Narrow Content', 'rever'),
                    'img' => REVER_DIR . 'assets/img/single_narrow.png'
                ),
                'fullwidth-content' => array(
                    'title' => esc_html__('Fullwidth Content', 'rever'),
                    'img' => REVER_DIR . 'assets/img/single_fullwidth.png'
                ),
            ),
        ),      
        Array(
            'name' => esc_html__('Choose Featured Media Layout', 'rever'),
            'id' => 'single_media',
            'std' => '',
            'desc' => esc_html__('Default will follow the Theme Option setting.', 'rever'),
            'type' => 'layout',
            'options' => array(
                '' => array(
                    'title' => esc_html__('Default', 'rever'),
                    'img' => REVER_DIR . 'assets/img/default_option.png'
                ),
                'small' => array(
                    'title' => esc_html__('Featured area small', 'rever'),
                    'img' => REVER_DIR . 'assets/img/media_small.png'
                ),
                'large' => array(
                    'title' => esc_html__('Featured area large', 'rever'),
                    'img' => REVER_DIR . 'assets/img/media_large.png'
                ),
                'large2' => array(
                    'title' => esc_html__('Featured area large 2', 'rever'),
                    'img' => REVER_DIR . 'assets/img/media_large2.png'
                ),
                'fullwidth' => array(
                    'title' => esc_html__('Featured area full', 'rever'),
                    'img' => REVER_DIR . 'assets/img/media_fullwidth.png'
                ),
                'none' => array(
                    'title' => esc_html__('Featured area None', 'rever'),
                    'img' => REVER_DIR . 'assets/img/slider_empty.png'
                )
            ),
        )      
    );
    
    
    add_meta_box('post_meta_settings', esc_html__('Post settings', 'rever'), 'rever_postmetabox', 'post', 'normal', 'core', $post_options);

}
